!to "cycles.prg", CBM

;-
VECTR    = $24
VECTR2   = $B4
;-

;NTSC 65 CYCLES PER LINE 262 SCANLINES
;IT 17030 CYCLES /DIV2 = 8515 = $2143

;PAL 63 CYCLES PER LINE 312 SCANLINEC
;IT 19656 CYCLES  /DIV2 = 9828 =$2664


;===========================
;=== basiline 0 sys 2061 ===
;===========================
          *=$0801
     !byte $0b,$08,$00,$00,$9e,$32
     !byte $30,$36,$31,$00,$00,$00
;-------------

			lda $ba
			cmp #$08
			bcs +
-			lda #$08
+			cmp #12
			bcs -
			sta $ba
;-

			LDA #$01
			STA $0286
			JSR $E544
;-
			jsr listen
			lda #$49
			jsr $ffa8
			jsr $ffae
			
			SEI
			CLD

			LDA #$0B
			STA $D011
			LDA #$00
			STA $D015
			LDA $D012
			CMP $D012
			BEQ *-3
			BMI *-8
			CMP #$20

			LDA #$00
			ADC #$00
			STA MY_NTSC

			ldy #$00
			sty $fb
			lda #$40
			sta $fc
			lda #$ea
			ldx #$30
-			sta ($fb),y
			iny
			bne -
			inc $fc
			dex
			bne -
			lda #$60
			sta $6663
			
		
			

			

;-
;FASTMW   
			LDA #<DRV
			STA VECTR
			LDA #>DRV
			STA VECTR+1

			LDA #<ADRDRV
			STA VECTR2
			LDA #>ADRDRV
			STA VECTR2+1
	    
;----------------

			LDX #3
LOOP			JSR LSTN
			LDA #$4D
			JSR $FFA8
			LDA #$2D
			JSR $FFA8
			LDA #$57
			JSR $FFA8
			LDA VECTR
			JSR $FFA8
			LDA VECTR+1
			JSR $FFA8
			LDA #$20
			JSR $FFA8
			LDY #$00
LOOP1		LDA (VECTR2),Y
			JSR $FFA8
			INY
			CPY #$20
			BNE LOOP1
			JSR $FFAE
			LDA VECTR
			CLC
			ADC #$20
			STA VECTR
			BCC *+4
			INC VECTR+1
			LDA VECTR2
			CLC
			ADC #$20
			STA VECTR2
			BCC *+4
			INC VECTR2+1
			DEX
			BNE LOOP
;-
			JSR LSTN
			LDX #$00
			LDA MEX1,X
			JSR $FFA8
			INX
			CPX #$06
			BNE *-9
			JSR $FFAE
			SEI
			LDA #$23
			STA $DD00

			BIT $DD00
			BVS *-3

;---------------
			LDY #$00
-			LDA ADENDDRV,Y
			JSR SENDDRIV
			INY
			BNE -

-			LDA ADENDDRV+$0100,Y
			JSR SENDDRIV
			INY
			BNE -		    

-       	 	LDA ADENDDRV+$0200,Y
			JSR SENDDRIV
			INY
			BNE -
	

			JSR SENDDRIV
			JSR $4000
			
			LDA #$03
			STA $DD00
			
			ldx #$30
			dex
			BNE *-1
			
			LDA #$23
			STA $DD00
			
			
			JSR POB
			STA LOW
			JSR POB
			STA HIGH
			
			LDX LOW
			LDA HIGH

			JSR $BDCD
			
			LDA #$0D
			JSR $FFD2
			JSR $FFD2
			
			LDA LOW
			SEC
			SBC #<19656
			tax
			LDA HIGH
			SBC #>19656
			JSR $BDCD
						
			LDA #$1B
			STA $D011
			CLI
			RTS
			

			


;==================
LOW
!BYTE 0
HIGH
!BYTE 0

MY_NTSC
!BYTE 0

;---------------------------
LSTN
listen
			lda #$00
			sta $90
			lda $ba
			jsr $ffb1
			lda #$6f
			jsr $ff93
			bit $90
			bmi +
			clc
			rts
+			ldx #5
			jmp ($0300)
;------------------------

;-
MEX1     !text "M-E"
         !byte <ABSRUN,>ABSRUN
;-
;=========================================================
FINDSYNC = $F556
IDHEADER = $24
GCR3     = $54
;-
ADRDRV
;-
!PSEUDOPC $0146


;------  REDEFINED COS BAD ASSEMBLING
SERIAL = $1800
TRACK2   = $06
SECT2    = $07
TWRK2    = $0C
MYDATA   = $01FF
;-
DRV
GETBLK
         JSR CLRLINE
DRV2     LDA SERIAL
         BNE *-3
         PHP
         LDA SERIAL
         ASL
         PLP
         EOR SERIAL
         ASL
         ASL
         ASL
         NOP
         NOP
         NOP
         EOR SERIAL
         ASL
         NOP
         NOP
         NOP
         EOR SERIAL
ADRBLK   = *+2
         STA $0300,Y
         INY
         BNE DRV2
SETLINE  LDA #$08
STLINE   STA SERIAL
         RTS
CLRLINE  LDA #$01
         BNE STLINE
;-
ABSRUN   SEI
         LDA #$7A
         STA $1802
         JSR SETLINE
         JSR $F5E9
         LDX #$03
DRV1     JSR GETBLK
         INC ADRBLK
         DEX
         BNE DRV1
         INX
         STX ADRBLK
         JMP STRTLDR
;-
LIFO
;-
!REALPC
;-
ADENDDRV
;-

!PSEUDOPC $0300

;----------------------------
;-
BIN2SER  !byte $0F,$07,$0D,$05,$0B,$03
         !byte $09,$01
         !byte $0E,$06,$0C,$04,$0A,$02
         !byte $08,$00
;-
         !text "(C) BY WEGI"
;-
;-
SENDONE  TAY
         AND #%00001111
         TAX
         TYA
         LSR
         LSR
         LSR
         LSR
         TAY
         JSR CLRLINE
         LDA BIN2SER,X
         LDX SERIAL
         BNE *-3
         STA SERIAL
         ASL
         AND #%00001010
         STA SERIAL
         LDA BIN2SER,Y
         STA SERIAL
         ASL
         AND #%00001010
         STA SERIAL
         JMP SETLINE
;-
GETONE   SEI
         LDY #$FF
         JSR GETBLK
         LDA MYDATA
         STA TWRK2
         RTS
;-
;----------------------------
STRTLDR
		sei

		
		JSR GETONE
		
		lda #$ff
		STA $1804
		STA $1805
		
		LDA $1800
		CMP $1800
		BEQ *-3
		
		lda $1804
		ldy $1805
		sta $06
		sty $07

		LDX #0
		DEX
		BNE *-1
		
		lda #$ff
		sec
		sbc $06
		sta $06
		
		lda #$ff
		sbc $07
		sta $07
		
		lda $06
		jsr SENDONE
		lda $07
		jsr SENDONE
		

		
		

		sec
		rol $1c
		cli
		RTS
;----------------------------		


!REALPC

;=========================================================
!align 255,0

;-
SENDDRIV BIT $DD00
         BVC *-3
         PHA
         LSR
         LSR
         LSR
         LSR
         TAX
         SEC
	    SEI
X4       LDA $D012
         SBC #$32
         BCC X5
         AND #$07
         BEQ X4
X5       LDA #$03
         STA $DD00
         LDA TABKON,X
         STA $DD00
         LSR
         LSR
         AND #$F7
         STA $DD00
         PLA
         AND #$0F
         TAX
         LDA TABKON,X
         STA $DD00
         LSR
         LSR
         AND #$F7
         STA $DD00
         LDA #$23
         NOP
         NOP
         BIT $EA
         STA $DD00
         RTS
;-
TABKON   !byte $07,$87,$27,$A7,$47,$C7
         !byte $67,$E7
         !byte $17,$97,$37,$B7,$57,$D7
         !byte $77,$F7
;----------------------
;---------------------
POB      BIT $DD00
         BVC *-3
	    SEI
         SEC
RASTER   LDA $D012
         SBC #$32
         BCC POB2
         AND #$07
         BEQ RASTER
POB2     LDA #$03
         STA $DD00
		LDA MY_NTSC
		BEQ *+2
         NOP
         LDX #$23
         LDA $DD00
         LSR
         LSR
         EOR $DD00
         LSR
         LSR
         EOR $DD00
         LSR
         LSR
         EOR $DD00
         STX $DD00
         EOR #$03
         RTS
;---------------------