!to "spin.prg", CBM

;-
VECTR    = $24
VECTR2   = $B4
;-



;===========================
;=== basiline 0 sys 2061 ===
;===========================
          *=$0801
     !byte $0b,$08,$00,$00,$9e,$32
     !byte $30,$36,$31,$00,$00,$00
;-------------

			lda $ba
			cmp #$08
			bcs +
-			lda #$08
+			cmp #12
			bcs -
			sta $ba
;-
			LDA #$7F
			STA $DC0D
			STA $DD0D
			BIT $DC0D
			LDA #0
			STA $D01A
			INC $D019
			LDA #$01
			STA $0286
			JSR $E544
;-
			jsr listen
			lda #$49
			jsr $ffa8
			jsr $ffae
			
			SEI
			CLD

			LDA #$1B
			STA $D011
			LDA #$00
			STA $D015
			LDA $D012
			CMP $D012
			BEQ *-3
			BMI *-8
			CMP #$20

			LDA #$00
			ADC #$00
			STA MY_NTSC


			

;-
;FASTMW   
			LDA #<DRV
			STA VECTR
			LDA #>DRV
			STA VECTR+1

			LDA #<ADRDRV
			STA VECTR2
			LDA #>ADRDRV
			STA VECTR2+1
	    
;----------------

			LDX #3
LOOP			JSR LSTN
			LDA #$4D
			JSR $FFA8
			LDA #$2D
			JSR $FFA8
			LDA #$57
			JSR $FFA8
			LDA VECTR
			JSR $FFA8
			LDA VECTR+1
			JSR $FFA8
			LDA #$20
			JSR $FFA8
			LDY #$00
LOOP1		LDA (VECTR2),Y
			JSR $FFA8
			INY
			CPY #$20
			BNE LOOP1
			JSR $FFAE
			LDA VECTR
			CLC
			ADC #$20
			STA VECTR
			BCC *+4
			INC VECTR+1
			LDA VECTR2
			CLC
			ADC #$20
			STA VECTR2
			BCC *+4
			INC VECTR2+1
			DEX
			BNE LOOP
;-
			JSR LSTN
			LDX #$00
			LDA MEX1,X
			JSR $FFA8
			INX
			CPX #$06
			BNE *-9
			JSR $FFAE
			SEI
			LDA #$23
			STA $DD00

			BIT $DD00
			BVS *-3

;---------------
			LDY #$00
-			LDA ADENDDRV,Y
			JSR SENDDRIV
			INY
			BNE -

-			LDA ADENDDRV+$0100,Y
			JSR SENDDRIV
			INY
			BNE -		    

-       	 	LDA ADENDDRV+$0200,Y
			JSR SENDDRIV
			INY
			BNE -
	


			LDA #<IRQ
			STA $FFFE
			LDA #>IRQ
			STA $FFFF
			

			
			LDX #0
			STX OUR_SEC
-			
			LDA #$20
			STA $0400,X
			STA $0500,X
			STA $0600,X
			STA $06E8,X
			LDA #1
			STA $D800,X
			STA $D900,X
			STA $DA00,X
			STA $DB00,X
			inx
			BNE -
			
			LDA #$30
			STA $0450
			STA $0451
			STA $0452
			STA $0453
			LDA #0
			STA IRQ_CNTR
			STA IRQ_CNTR+1
			
			SEI
			LDA #$35
			STA $01
			LDA OUR_SEC
			JSR SENDDRIV
			JSR POB
			LDX $D012
			CPX $D012
			BEQ *-3
			INC OUR_SEC
			INC OUR_SEC
			

			LDA #$2A
			STA $04A0
			
			STX $D012
			LDA #$01
			STA $D01A
			INC $D019



			CLI
			LDX #0
-			LDA CLOCK,X
			STA $0400,X
			INX
			CPX #7
			BCC -

;====================================================================
MAINLOOP
			LDA OUR_SEC
			JSR SENDDRIV
			JSR POB
			
			TAX
			LDA #$2A
			STA $04A0,X
			
			LDY #$03
			CPX #0
			BNE NOCOUNT
			
CNT01		LDX $0450,Y
			INX
			TXA
			CPX #$3A
			BCC +
			LDA #$30
			STA $0450,Y
			DEY
			BPL CNT01
			INY
+			STA $0450,Y
NOCOUNT		LDA $DC01
			BMI +
			JMP FINISH
+			AND #$10
			BNE +
			JSR COPY_DATA2
+			LDA IRQ_CNTR
			CMP #$B8
			BNE +
			LDA IRQ_CNTR+1
			CMP #$0B
			BNE +
			JSR COPY_DATA
+
			INC OUR_SEC
			INC OUR_SEC
			LDA OUR_SEC
			CMP #20
			BCC MAINLOOP
			LDA #0
			STA OUR_SEC
			JSR CLEAR
			JMP MAINLOOP
;==========================
;---------
CLEAR
			LDX #20
			LDA #32
-			STA $04A0,X
			DEX
			DEX
			BPL -
			RTS
;---------
COPY_DATA
			LDA #0
			STA IRQ_CNTR
			STA IRQ_CNTR+1
			
			LDX #$06
-			LDA $0400,X
			STA $0568,X
			LDA $0450,X
			STA $05B8,X
			dex
			BPL -
			LDX #20
-			LDA $04A0,X
			STA $0608,X
			DEX
			BPL -
			RTS
;=================
COPY_DATA2

			
			LDX #$06
-			LDA $0400,X
			STA $06D0,X
			LDA $0450,X
			STA $0720,X
			dex
			BPL -
			LDX #20
-			LDA $04A0,X
			STA $0770,X
			DEX
			BPL -
			
			RTS
;=================================================
;==================
FINISH
			LDA #$FF
			JSR SENDDRIV
			SEI
			LDA #$00
			STA $D01A
			INC $D019
			LDA #$37
			STA $01
			JSR $FDA3
			
			LDX #22
			LDA #$11
-			JSR $FFD2
			DEX
			BNE -
			
			cli
			JMP $E383
			rts
			


;==================
OUR_SEC
!BYTE 0
MY_NTSC
!BYTE 0
IRQ_CNTR
!BYTE 0,0
CLOCK
!TEXT "0:00:00"
!BYTE 0
IRQ
			pha
			txa
			pha
			tya
			pha
INC $D020			
			INC $D019
			
			INC IRQ_CNTR
			BNE +
			INC IRQ_CNTR+1
+			
			LDA #$30
			
			LDX $0406
			inx
			inx
			CPX #$3A
			BCS +
			STX $0406
			JMP REST_IRQ
+			STA $0406
			LDX $0405
			INX
			CPX #$3A
			BCS +
			STX $0405
			JMP REST_IRQ
+			STA $0405
			LDX $0403
			INX
			CPX #$3A
			BCS +
			STX $0403
			JMP REST_IRQ
+			STA $0403
			LDX $0402
			INX
			CPX #$36
			BCS +
			STX $0402
			JMP REST_IRQ
+			STA $0402
			LDX $0400
			INX
			CPX #$3A
			BCS +
			STX $0400
			JMP REST_IRQ
+			STA $0400

REST_IRQ

DEC $D020
			pla
			tay
			pla
			tax
			pla
			RTI
;---------------------------
LSTN
listen
			lda #$00
			sta $90
			lda $ba
			jsr $ffb1
			lda #$6f
			jsr $ff93
			bit $90
			bmi +
			clc
			rts
+			ldx #5
			jmp ($0300)
;------------------------

;-
MEX1     !text "M-E"
         !byte <ABSRUN,>ABSRUN
;-
;=========================================================
FINDSYNC = $F556
IDHEADER = $24
GCR3     = $54
;-
ADRDRV
;-
!PSEUDOPC $0146


;------  REDEFINED COS BAD ASSEMBLING
SERIAL = $1800
TRACK2   = $06
SECT2    = $07
TWRK2    = $0C
MYDATA   = $01FF
;-
DRV
GETBLK
         JSR CLRLINE
DRV2     LDA SERIAL
         BNE *-3
         PHP
         LDA SERIAL
         ASL
         PLP
         EOR SERIAL
         ASL
         ASL
         ASL
         NOP
         NOP
         NOP
         EOR SERIAL
         ASL
         NOP
         NOP
         NOP
         EOR SERIAL
ADRBLK   = *+2
         STA $0300,Y
         INY
         BNE DRV2
SETLINE  LDA #$08
STLINE   STA SERIAL
         RTS
CLRLINE  LDA #$01
         BNE STLINE
;-
ABSRUN   SEI
         LDA #$7A
         STA $1802
         JSR SETLINE
         JSR $F5E9
         LDX #$03
DRV1     JSR GETBLK
         INC ADRBLK
         DEX
         BNE DRV1
         INX
         STX ADRBLK
         JMP STRTLDR
;-
LIFO
;-
!REALPC
;-
ADENDDRV
;-

!PSEUDOPC $0300
		JMP READ_T
;----------------------------
;-
BIN2SER  !byte $0F,$07,$0D,$05,$0B,$03
         !byte $09,$01
         !byte $0E,$06,$0C,$04,$0A,$02
         !byte $08,$00
;-
         !text "(C) BY WEGI"
;-
;-
SENDONE  TAY
         AND #%00001111
         TAX
         TYA
         LSR
         LSR
         LSR
         LSR
         TAY
         JSR CLRLINE
         LDA BIN2SER,X
         LDX SERIAL
         BNE *-3
         STA SERIAL
         ASL
         AND #%00001010
         STA SERIAL
         LDA BIN2SER,Y
         STA SERIAL
         ASL
         AND #%00001010
         STA SERIAL
         JMP SETLINE
;-
GETONE   SEI
         LDY #$FF
         JSR GETBLK
         LDA MYDATA
         STA TWRK2
         RTS
;-
;----------------------------
STRTLDR
		LDA #17
		STA $06
		LDA #0
		STA $07
		
		LDA #$E0
		STA $00
		CLI
		LDA $00
		BMI *-2
		sec
		rol $1c
		RTS
;----------------------------		
READ_T
		JSR GETONE
		CMP #22
		BCC +		
;EXIT_READ
		LDA #$01
		JMP $F969
+		STA $07
;====================
		JSR $F50A


;=====================
		LDA $07
		JSR SENDONE
		LDA $1C00
		EOR #8
		STA $1C00
		JMP READ_T
		
EDRV



!REALPC

;=========================================================
!align 255,0

;-
SENDDRIV BIT $DD00
         BVC *-3
         PHA
         LSR
         LSR
         LSR
         LSR
         TAX
         SEC
	    SEI
X4       LDA $D012
         SBC #$32
         BCC X5
         AND #$07
         BEQ X4
X5       LDA #$03
         STA $DD00
         LDA TABKON,X
         STA $DD00
         LSR
         LSR
         AND #$F7
         STA $DD00
         PLA
         AND #$0F
         TAX
         LDA TABKON,X
         STA $DD00
         LSR
         LSR
         AND #$F7
         STA $DD00
         LDA #$23
         NOP
         NOP
         BIT $EA
         STA $DD00
	    CLI
         RTS
;-
TABKON   !byte $07,$87,$27,$A7,$47,$C7
         !byte $67,$E7
         !byte $17,$97,$37,$B7,$57,$D7
         !byte $77,$F7
;----------------------
;---------------------
POB      BIT $DD00
         BVC *-3
	    SEI
         SEC
RASTER   LDA $D012
         SBC #$32
         BCC POB2
         AND #$07
         BEQ RASTER
POB2     LDA #$03
         STA $DD00
		LDA MY_NTSC
		BEQ *+2
         NOP
         LDX #$23
         LDA $DD00
         LSR
         LSR
         EOR $DD00
         LSR
         LSR
         EOR $DD00
         LSR
         LSR
         EOR $DD00
         STX $DD00
         EOR #$03
		CLI
         RTS
;---------------------